//ModbusRTU.h

#ifndef _smodbusrtu_h_
#define _smodbusrtu_h_

#include "config.h"
#include <Arduino.h>

#ifndef  _szbuf  //если размер буфера не определён
#define  _szbuf  0x40
#endif

//адрес устройства
#ifndef  _MRTU_Addr
#define  _MRTU_Addr  16  //адрес устройства по умолчанию
#endif

//определения
#define  _ADDR_MADDR  0x00  //адрес адреса устройства
#define  _ADDR_MCMD  0x01  //адрес команды
//cmd 0x03
#define  _ADDR_03_START_REG_H   0x02  //адрес начального(старшего) байта первого регистра
#define  _ADDR_03_CNT_REG_H  0x04  //адрес старшего байта количества регистров
#define  _ADDR_03_INCRC  0x06  //адрес контрольной суммы
//cmd 0x04
#define  _ADDR_04_START_REG_H   0x02  //адрес начального(старшего) байта первого регистра
#define  _ADDR_04_CNT_REG_H  0x04  //адрес старшего байта количества регистров
#define  _ADDR_04_INCRC  0x06  //адрес контрольной суммы
//cmd 0x06
#define _ADDR_06_ADDR_REG_H  0x02  //адрес (старший байт) регистра
#define _ADDR_06_DAT_H  0x04  //адрес старшего байта данных
#define _ADDR_06_INCRC  0x06  //адрес контрольной суммы


//возвращаемые ошибки
#define _ILLEGAL_FUNCTION  0x01
#define _ILLEGAL_DATA_ADDRESS  0x02

typedef struct _DAT_MRTU
{
  uint8_t  rxbuf[_szbuf];
  uint8_t  txbuf[_szbuf];
  uint8_t  adrx;  //указатель на массив буфера приёма
  uint8_t  adtx;  //указатель на массив буфера передачи
} DAT_MRTU;

extern DAT_MRTU  dmrtu;

//инициализация
extern int16_t  sMRTU_INIT(void);

//контрольная сумма
extern uint16_t sMRTU_CRC(uint8_t* data, uint16_t len, uint8_t * tbuff);

//работа по приёму
extern int16_t MRTU_rWORK(void);
//работа по передаче
extern int16_t MRTU_sWORK(void);

#endif  //_smodbusrtu_h_


