#include <Wire.h>
#include "ComMotion.h"
#include "Multiservo.h"
#include "ModbusRTU.h"
#include "config.h"
#include "maindat.h"


MS  multiservo;
Multiservo servo[SERVO_COUNT];

/*
*********************
* рабочие данные * 
*********************
*/

//массив данных для сервомашин
int16_t  dservo[SERVO_COUNT]  ;
//массив данных для моторов
int16_t  dmotor[MOTOR_COUNT]  ;

//номер исполнения по I2C для последовательности - цель минимизировать простой по Serial
int  dnum;


void WParams()
{
    int i;  
    //значения сераомашин
    i  = 0;
    while(i < SERVO_COUNT)
    {
      servo[i].write(dservo[i]);
      delay(20);
      i++;
    }
    //значения моторов
    IndividualMotorControl(dmotor[0], dmotor[1], dmotor[2], dmotor[3]);
    //
    delay(20);
    //
}

void  setup()
{
  Wire.begin ();  // Required to support I2C communication
  sMRTU_INIT();
  Serial.begin(_sMRTU_Baudrate);
  //ComMotion
#if(_BC_Configurration > 0) //конфигурация ComMotion
#if(_test > 0x1F)  
  Serial.println("Config ComMotion ...");
#endif
  BasicConfig(_BC_i2c_mode,
  _BC_config,
  _BC_lovbat,
  _BC_M1_Imax,
  _BC_M2_Imax,
  _BC_M3_Imax,
  _BC_M4_Imax,
  _BC_i2c_nooffset,
  1);
#endif
#if(_test > 0x1F)  
  Serial.println("Set ComMotion ... to null values for motors");
#endif
  //init ComMotiom shield of 4 motor drivers
  IndividualMotorControl(_CM_M1_def, _CM_M2_def, _CM_M3_def, _CM_M4_def);
  for(int i = 0; i<MOTOR_COUNT; ++i)
    dmotor[i]  = 0;
  //init Multiservo
#if(_test > 0x1F)  
  Serial.println("Set Init Positions of multiservo");
#endif
  for (int i = 0; i < SERVO_COUNT; ++i)
  {
    servo[i].attach(i);
    servo[i].write(0);
    multiservo.pos[i]  = 0;
    dservo[i]  = 0;
    delay(20);
  }
  dnum = 0;
  delay(5000);
  //
}
void loop()
{
  int  i;
#if(_test == 0x10)
  char  inByte;
#elif(_test == 0x30)
  signed int pos = 0;
#elif (_test == 0x40)
  signed int pos1=0; 
  signed int pos2= 90; 
  signed int pos3=-90;
#elif(_test == 0x70)
  signed int pos1=0; 
  signed int pos2= 90; 
  signed int pos3=-90;
  signed int mot1 = 0;
  signed int mot2 = 255;
  signed int mot3 = -255;
#endif
  //test
#if(_test == 0x10)  //test Serial
  while(1)
  {
    if(Serial.available() > 0)
    {
      inByte = Serial.read();
      Serial.println(inByte);
    }
    //else
    //Serial.println("-----test----");*/
    delay(500);
  }
#elif(_test == 0x20)  //test ComMotion
  Serial.println("forward.");
  for (int i=0; i<_cmtest_max; i+= 5){
    Serial.print("Speed command: "); 
    Serial.println(i);
    IndividualMotorControl(i,i,i,i);
    delay(5000);
  }        
  //      
  IndividualMotorControl(0,0,0,0); 
  delay(2000);      
  Serial.println("reverse");                 
  for (int i=0; i>_cmtest_min; i-= 5){
    Serial.print("Speed command: "); 
    Serial.println(i);
    IndividualMotorControl(i,i,i,i);
    delay(5000);
  }      
  Serial.println("Start over in 10 sec.\n");      
  IndividualMotorControl(0,0,0,0); 
  delay(10000);
/*
***********************************************
ВЫБОР КОМПИЛЯЦИИ (_test = 0x21)
***********************************************
*/
#elif(_test == 0x21)  //test Status
  Serial.println("Status");
  ComMotionStatus(0,1);
  delay(5000);
/*
***********************************************
ВЫБОР КОМПИЛЯЦИИ (_test = 0x30)
***********************************************
*/
#elif(_test == 0x30)  //test Multiservo из примера
  for (i = 0; i < SERVO_COUNT; ++i)
  {
    for (pos = 0; pos <= 90; pos += 1) 
    {
      Serial.print("Servo num: "); 
      Serial.println(i); 
      Serial.print("Position: "); 
      Serial.println(pos);
      servo[i].write(pos);              
      delay(20);                       
    }
  }
  for (i = 0; i < SERVO_COUNT; ++i)
  {
    for (pos = 90; pos >= -90; pos -= 1) 
    {
      Serial.print("Servo num: "); 
      Serial.println(i); 
      Serial.print("Position: "); 
      Serial.println(pos);
      servo[i].write(pos);                
      delay(20);                       
    }
  }
/*
***********************************************
ВЫБОР КОМПИЛЯЦИИ (_test = 0x40)
***********************************************
*/
#elif(_test == 0x40)  //test Multiservo для поворота камеры
  while(1)
  {
    if(pos1 < 90)
    {
      pos1 += 1;
      i = 4;
      while(i > 0)
      {
        servo[0].write(pos1);
        servo[1].write(pos1);
        i--;
      }
    }
    else
    {
      if(pos2 > -90)
      {
        pos2 -= 1;
        pos1 += 1;
        i = 4;
        while(i > 0)
        {
          servo[0].write(pos2);
          servo[1].write(pos2);
          i--;
        }
      }
      else
      {
        if(pos3 < 0)
        {
          pos3 += 1;
          pos1 += 1;
          i = 4;
          while(i > 0)
          {
            servo[0].write(pos3);
            servo[1].write(pos3);
            i--;
          }
        }
        else
        {
          pos1 = 0;
          pos2 = 90;
          pos3 = -90;
        }
      }
    }
    delay(100);
  }
/*
***********************************************
ВЫБОР КОМПИЛЯЦИИ (_test = 0x70)
***********************************************
*/
#elif(_test == 0x70)
  while(1)
  {
    if(pos1 < 90)
    {
      pos1 += 1;
      servo[0].write(pos1);
      servo[1].write(pos1);
    }
    else
    {
      if(pos2 > -90)
      {
        pos2 -= 1;
        servo[0].write(pos2);
        servo[1].write(pos2);
      }
      else
      {
        if(pos3 < 0)
        {
          pos3 += 1;
          servo[0].write(pos3);
          servo[1].write(pos3);
        }
        else
        {
          pos1 = 0;
          pos2 = 90;
          pos3 = -90;
        }
      }
    }
    //
    delay(20);
    //
    if(mot1 < 255)
    {
      mot1 += 1;
      IndividualMotorControl(mot1,mot1,mot1,mot1);
    }
    else
    {
      if(mot2 > -255)
      {
        mot2 -= 1;
        IndividualMotorControl(mot2,mot2,mot2,mot2);
      }
      else
      {
        if(mot3 < 0)
        {
          mot3 += 1;
          IndividualMotorControl(mot3,mot3,mot3,mot3);
        }
        else
        {
          mot1 = 0;
          mot2 = 255;
          mot3 = -255;
        }
      }
    }
    delay(20);
  }
/*
***********************************************
ВЫБОР КОМПИЛЯЦИИ (_test = 0x71)
ТЕСТ по последовательному порту (ввод символа)
0 - исходные параметры (скорость = 0, позиционирование сервомашин в 0)
1 - увеличить скорость вперёд (уменьшить скорость назад)
2 - увеличить скорость назад (уменьшить скорость вперёд)
3 - камера влево
4 - камера вправо
5 - камера вверх
6 - камера вниз
***********************************************
*/
#elif(_test == 0x71)
  int rd_sz = Serial. available();
  char control;
  if(rd_sz > 0)
    control = Serial.read();
  else
    control = 0xFF;
  switch(control)
  {
      case '0':
          dmotor[0] = _CM_M1_def;
          dmotor[1] = _CM_M2_def;
          dmotor[2] = _CM_M3_def;
          dmotor[3] = _CM_M4_def;
          i = 0;
          while(i < SERVO_COUNT)
          {
              dservo[i] = 0;
              i++;
          }  
          break;
      case '1':
        if(dmotor[0] < _cmtest_max)
        {
          dmotor[0]++;
          dmotor[1]++;
          dmotor[2]++;
          dmotor[3]++;
        }
        break;
      case '2':
        if(dmotor[0] > _cmtest_min)
        {
          dmotor[0]--;
          dmotor[1]--;
          dmotor[2]--;
          dmotor[3]--;
        }
        break;
      case '3':
        if(dservo[0] < wpos_max[0])
          dservo[0]++;
        break;
      case '4':
        if(dservo[0] > wpos_min[0])
          dservo[0]--;
        break;
      case '5':
        if(dservo[1] < wpos_max[1])
          dservo[1]++;
        break;
      case '6':
        if(dservo[1] > wpos_min[1])
          dservo[1]--;
        break;
      default:
        break;
  }
   //значения сераомашин
    i  = 0;
    while(i < SERVO_COUNT)
    {
      servo[i].write(dservo[i]);
      delay(20);
      i++;
    }
    //значения моторов
    IndividualMotorControl(dmotor[0], dmotor[1], dmotor[2], dmotor[3]);
    //состояние в Serial
    Serial.print("Motors: "); Serial.print(dmotor[0]);  Serial.print("; "); Serial.print(dmotor[1]); Serial.print("; "); Serial.print(dmotor[2]); Serial.print("; "); Serial.print(dmotor[3]);
    Serial.print("  Position: "); Serial.print(dservo[0]);  Serial.print("; "); Serial.println(dservo[1]);
     //Serial.println("motors " dmotor[0] ); //, dmotor[1], dmotor[2], dmotor[3]);
    delay(20);
#else //штатная работа
  //MRTU_rWORK();
  //
  switch(dnum)
  {
    //Multiservo
    case 0:
      servo[0].write(dservo[0]);
      dnum++;
      break;
     case 1:
      servo[1].write(dservo[1]);
      dnum++;
      break;
    case 2:
      servo[2].write(dservo[2]);
      dnum++;
      break;
    case 3:
      servo[3].write(dservo[3]);
      dnum++;
      break;
    case 4:
      servo[4].write(dservo[4]);
      dnum++;
      break;
    case 5:
      servo[5].write(dservo[5]);
      dnum++;
      break;
    case 6:
      servo[6].write(dservo[6]);
      dnum++;
      break;
    case 7:
      servo[7].write(dservo[7]);
      dnum++;
      break;
    case 8:
      servo[8].write(dservo[8]);
      dnum++;
      break;
    case 9:
      servo[9].write(dservo[9]);
      dnum++;
      break;
    case 10:
      servo[10].write(dservo[10]);
      dnum++;
      break;
    case 11:
      servo[11].write(dservo[11]);
      dnum++;
      break;
    case 12:
      servo[12].write(dservo[12]);
      dnum++;
      break;
    case 13:
      servo[13].write(dservo[13]);
      dnum++;
      break;
    case 14:
      servo[14].write(dservo[14]);
      dnum++;
      break;
    case 15:
      servo[15].write(dservo[15]);
      dnum++;
      break;
    case 16:
      servo[16].write(dservo[16]);
      dnum++;
      break;
    case 17:
      servo[17].write(dservo[17]);
      dnum++;
      break;
    //ComMotion driver for 4 motors - значения моторов
    case 18:
      IndividualMotorControl(dmotor[0], dmotor[1], dmotor[2], dmotor[3]);
      dnum = 0;
      break;
    default:
      dnum = 0;
      break;
  }
  //
  delay(20);
  MRTU_rWORK();
#endif
}








